# ASLL

proc mc:harksok {e id} {
    global thi race prof

    if { [llength $e] > 1 } {
        set wid [lindex $e 0]
    } else {
        set wid $e
    }

    if { [info exist thi($wid)] } {
        set ps [mc:getstat str $id]
        set pl [mc:getstat dex $id]
        set pm [mc:getstat wis $id]
        set pi [mc:getstat int $id]
        set pv [mc:getstat con $id]

        if { [llength $e] > 1 } {
            set harks [mc:wget [lindex $e 1] hark $id]
        } else {
            set harks [mc:wget $wid hark]
        }

        set mins 0
        set minl 0
        set minm 0
        set mini 0
        set minv 0

        set mins [expr [lindex $harks 0] + 5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 1] ]
        set minl [expr [lindex $harks 1] + 5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 2] ]
        set minm [expr [lindex $harks 2] + 5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 3] ]
        set mini [expr [lindex $harks 3] + 5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 4] ]
        set minv [expr [lindex $harks 4] + 5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) 5] ]

        if { $ps < $mins } { return 0 }
        if { $pl < $minl } { return 0 }
        if { $pm < $minm } { return 0 }
        if { $pi < $mini } { return 0 }
        if { $pv < $minv } { return 0 }

        return 1
    }

    return 0
}
