# turn off - .ms mc(tot.debug) 1
# turn on  - .ms mc(tot.debug) 0

if {![info exist mc(tot.client)]} {
  set mc(tot.client) "Joker"
  set mc(tot.enable) 0
  set mc(tot.dpot)   0
  set mc(tot.state)  0
  set mc(tot.max)    100
  set mc(tot.min)    10
  set mc(tot.ostatok) 110
  set mc(tot.debug)   1
  set mc(tot.round.num) 0

  set mc(tot.cmax)    500
  set mc(tot.cmin)    10
  set mc(tot.cdpot)   0
  set mc(tot.cenable) 0
# 0 - nobets
# 1 - recive bets
  putlog "...Loading server part of Arena-total..."
}


bind bot - arena.total  mc:tot:parsefromclient

proc mc:tot:toclient {cm {param ""}} {
   global mc

   if {!$mc(tot.enable)} { return }

   if {[islinked $mc(tot.client)]} {
     putbot $mc(tot.client) "arena.total $cm [mc:tobotnet $param]"
   } elseif {[info exist mc(tot.server)]} {
     mc:tot:parsefromserver $mc(tot.server) "arena.total" "$cm [mc:tobotnet $param]"
     if {$mc(tot.debug)} { putlog ">client $cm $param" }
   }
}

proc mc:tot:log {n c t} {
   global col
   putlog "total$col(hblk)\($col(cl)[ms:dfl $n]$col(hblk)\)$col(hred) $c$col(hblk):$col(cl) $t"
#   putserv "PRIVMSG #arena :total$col(hblk)\($col(cl)[ms:dfl $n]$col(hblk)\)$col(hred) $c$col(hblk):$col(cl) $t"
}

proc mc:tot:startgame {} {
   global mc mcc

   mc:tot:toclient initcomlist
   set mc(tot.sv.clist) ""
   foreach mn [array names mcc] {
     set mc(tot.sv.clist) [lappend mc(tot.sv.clist) $mcc($mn)]
     mc:tot:toclient addcomlist $mcc($mn)
   }
   if {[array size mcc]>=12} {
      set mc(tot.sv.cmax) 4
      set mc(tot.cenable) 4
   } elseif {[array size mcc]>=9} {
      set mc(tot.sv.cmax) 3
      set mc(tot.cenable) 3
   } elseif {[array size mcc]>=6} {
      set mc(tot.sv.cmax) 2
      set mc(tot.cenable) 2
   } else {
      set mc(tot.sv.cmax) 1
      set mc(tot.cenable) 1
   }


   mc:tot:toclient donecomlist $mc(tot.sv.cmax)
   set mc(tot.round.num) 0
   if {[info exist mc(tot.cbets)]} {
      foreach bet $mc(tot.cbets) {
         if {!$mc(tot.debug)} { mc:setstat gold [lindex $bet 0] [expr [mc:getstat gold [lindex $bet 0]] + [lindex $bet 2]] }
      }
      unset mc(tot.cbets)
   }
}

proc mc:tot:endgame {} {
   global mc mcc liv mcr col

   foreach nk [array names liv] { set winc($mcr($nk)) 1 }
   set i 0
   set wl ""
   foreach mn [array names mcc] {
      if {[array exist winc] && [info exist winc($mn)]} {
         set wl [lappend wl $i]
      }
      incr i
   }
   mc:tot:log "$col(cyn)Server" WinComNum $wl

   if {[info exist mc(tot.cbets)]} {
      set bet_summ 0
      set win_bet_summ 0
      set win_bet ""

      foreach bet $mc(tot.cbets) {
        if {[lsearch -exact $wl [lindex $bet 1]] != -1} {
          incr win_bet_summ [lindex $bet 2]
          set win_bet [lappend win_bet $bet]
        }
        incr bet_summ [lindex $bet 2]
      }

      if {$win_bet_summ != 0} {
        incr bet_summ $mc(tot.cdpot)
        set mc(tot.cdpot) 0
        set koef [expr 1.01 * $bet_summ / $win_bet_summ ]

        foreach bet $win_bet {
          set id [lindex $bet 0]
          if {[array exist wbet] && [info exist wbet($id)]} {
             set wbet($id) [expr $wbet($id) + 1.0 * [lindex $bet 2] * $koef]
          } {
             set wbet($id) [expr 1.0 * [lindex $bet 2] * $koef]
          }
        }
      } { incr mc(tot.cdpot) $bet_summ }
      unset mc(tot.cbets)
   }

   set killlist ""
   if {$wl == ""} {
     set winlist ""
   } else {
     foreach i $wl { set killlist [lappend killlist [lindex $mc(tot.sv.clist) $i]] }

     set winlist ""
     if {[array exist wbet]} {
       foreach id [array names wbet] {
         set wbet($id) [expr round($wbet($id))]
         set winlist [lappend winlist "[mc:getstat nick $id] $wbet($id)"]
         if {!$mc(tot.debug)} { mc:setstat gold $id [expr [mc:getstat gold $id] + $wbet($id)] }
       }
     }
   }

   mc:tot:toclient clendgame "{$killlist} {$winlist} $mc(tot.cdpot)"
   unset mc(tot.sv.clist)
   set mc(tot.cenable) 0
}

proc mc:tot:startround {idlist} {
   global mc

   incr mc(tot.round.num)
   if {[info exist mc(tot.bets)]} {
      foreach bet $mc(tot.bets) {
#         if {!$mc(tot.debug)} { }
         mc:setstat tgold [lindex $bet 0] [expr [mc:getstat tgold [lindex $bet 0]] + [lindex $bet 2]]
      }
      unset mc(tot.bets)
   }
   set nicklist ""
   foreach id $idlist { set nicklist [lappend nicklist [mc:getstat nick $id]] }
   set mc(tot.list)  $idlist
   set mc(tot.state) 1
   mc:tot:toclient nicklist "[mc:tot:getmaxbets] $nicklist"
}

proc mc:tot:endround {deadid} {
   global mc

   if {[info exist mc(tot.bets)]} {
      set bet_summ 0
      set win_bet_summ 0
      set win_bet ""

      foreach bet $mc(tot.bets) {
        if {[lsearch -exact $deadid [lindex $bet 1]] != -1} {
          incr win_bet_summ [lindex $bet 2]
          set win_bet [lappend win_bet $bet]
        }
        incr bet_summ [lindex $bet 2]
      }

      if {$win_bet_summ != 0} {
        incr bet_summ $mc(tot.dpot)
        set mc(tot.dpot) 0
        set koef [expr 1.01 * $bet_summ / $win_bet_summ ]

        foreach bet $win_bet {
          set id [lindex $bet 0]
          if {[array exist wbet] && [info exist wbet($id)]} {
             set wbet($id) [expr $wbet($id) + 1.0 * [lindex $bet 2] * $koef]
          } {
             set wbet($id) [expr 1.0 * [lindex $bet 2] * $koef]
          }
        }
      } { incr mc(tot.dpot) $bet_summ }
      unset mc(tot.bets)
   }

   set killlist ""
   if {$deadid == ""} {
     set winlist ""
   } else {
     foreach id $deadid { set killlist [lappend killlist [mc:getstat nick $id]] }

     set winlist ""
     if {[array exist wbet]} {
       foreach id [array names wbet] {
         set wbet($id) [expr round($wbet($id))]
         set winlist [lappend winlist "[mc:getstat nick $id] $wbet($id)"]
#         if {!$mc(tot.debug)} { }
         mc:setstat tgold $id [expr [mc:getstat tgold $id] + $wbet($id)]
       }
     }
   }

   mc:tot:toclient roundend "{$killlist} {$winlist} $mc(tot.dpot)"
   set mc(tot.state) 0
   unset mc(tot.list)
   if {$mc(tot.cenable)} {
     incr mc(tot.cenable) -1
     if {!$mc(tot.cenable)} {
       mc:tot:toclient cdisable
     }
   }
}

proc mc:tot:recivestat {p} {
   global mc

   set id [tolower [lindex $p 0]]
   if {[mc:userexists $id]} {
     mc:tot:toclient statreply "[lindex $p 0] [mc:getstat tgold $id] [mc:getstat gold $id]"
   }
}

proc mc:tot:join {p} {
   global mc
   if {$mc(tot.state) == 0} { return }
   set id [tolower $p]
   if {![mc:userexists $id]} { return  }
   mc:tot:toclient saylist $p
}

proc mc:tot:getmaxbets {} {
   global mc

#   return 10
   if {![info exist mc(tot.list)]} { return 0 }

   if {[llength $mc(tot.list)]>=12} { return 4 }
   if {[llength $mc(tot.list)]>=9} { return 3 }
   if {[llength $mc(tot.list)]>=6} { return 2 }
   return 1
}

proc mc:tot:recivebet {p} {
   global mc

   if { $mc(tot.state) == 0 } { return }
   set id   [tolower [lindex $p 0]]
   set num  [lindex $p 1]
   set bet  [lindex $p 2]
   set bcount 0
   set bexist 0


   if {[info exist mc(tot.bets)]} {
     foreach nbet $mc(tot.bets) {
       if {[lindex $nbet 0] == $id} {
         incr bcount
         if {[expr 1 + [lsearch -exact $mc(tot.list) [lindex $nbet 1]]] == $num} {
            set bexist 1
         }
       }
     }
   }

   set flag 0
   if {![isnumber $num] || $num < 1 || $num > [llength $mc(tot.list)] } {
      set flag 5
   } elseif {![mc:userexists $id]} {
      set flag 3
   } elseif {![mc:checkident $id]} {
      set flag 7
   } elseif {![isnumber $bet]} {
      set flag 6
   } elseif {$bcount>=[mc:tot:getmaxbets] && $bet != 0 && !$bexist} {
      set flag 11
      set bet [mc:tot:getmaxbets]
   } elseif {$bet < $mc(tot.min) && $bet != 0 } {
      set flag 2
      set bet $mc(tot.min)
   } elseif {$bet > $mc(tot.max)} {
      set flag 1
      set bet $mc(tot.max)
   }

   if { $flag != 5 } { set num [lindex $mc(tot.list) [expr $num - 1]] }

   if { $flag == 0 || $flag == 1 } {
     set money [mc:getstat tgold $id]
     set sbet 0

     if {[info exist mc(tot.bets)]} {
       set obet ""
       foreach nbet $mc(tot.bets) {
         if {[lindex $nbet 0] == $id && [lindex $nbet 1] == $num } {
           set flag 8
           set sbet [lindex $nbet 2]
           incr money $sbet
#           if {!$mc(tot.debug)} { }
           mc:setstat tgold $id $money
         } {
           set obet [lappend obet $nbet]
         }
       }
       set mc(tot.bets) $obet
     }

     if {$bet == 0 && $sbet == 0} {
       set flag 10
     } elseif {$bet == 0} {
       set flag 9
       set bet $sbet
       if {$mc(tot.bets)==""} { unset mc(tot.bets) }
     } elseif {[expr $bet+$mc(tot.ostatok)]>$money} {
       set flag 4
       set bet $money
     } else {
       if {![info exist mc(tot.bets)]} { set mc(tot.bets) "" }
       set mc(tot.bets) [lappend mc(tot.bets) "$id $num $bet"]
#       if {!$mc(tot.debug)} { }
       mc:setstat tgold $id [expr $money - $bet]
     }
   }

   if { $flag != 5 } { set num [mc:getstat nick $num] }
   set cml ""
   switch -- $flag {
     0 { set cml "BET" }
     1 { set cml "BET" }
     8 { set cml "REBET" }
     9 { set cml "CLEAR" }
   }

   if {$cml!=""} { mc:tot:log [lindex $p 0] $cml "$bet on $num" }
   mc:tot:toclient betreply "$flag [lindex $p 0] $num $bet"
}

proc mc:tot:recivecbet {p} {
   global mc

   if { $mc(tot.state) == 0 } { return }
   if {!$mc(tot.cenable)} { return }
   set id   [tolower [lindex $p 0]]
   set num  [lindex $p 1]
   set bet  [lindex $p 2]
   set bcount 0
   set bexist 0

   if {[info exist mc(tot.cbets)]} {
     foreach nbet $mc(tot.cbets) {
       if {[lindex $nbet 0] == $id} {
         incr bcount
         if {[expr 1 + [lindex $nbet 1]] == $num} {
            set bexist 1
         }
       }
     }
   }

   set flag 0
   if {![isnumber $num] || $num < 1 || $num > [llength $mc(tot.sv.clist)] } {
      set flag 5
   } elseif {![mc:userexists $id]} {
      set flag 3
   } elseif {![mc:checkident $id]} {
      set flag 7
   } elseif {![isnumber $bet]} {
      set flag 6
   } elseif {$bcount>=$mc(tot.sv.cmax) && $bet != 0 && !$bexist} {
      set flag 11
      set bet $mc(tot.sv.cmax)
   } elseif {$bet < $mc(tot.cmin) && $bet != 0 } {
      set flag 2
      set bet $mc(tot.cmin)
   } elseif {$bet > $mc(tot.cmax)} {
      set flag 1
      set bet $mc(tot.cmax)
   }

   if { $flag != 5 } { set num [expr $num - 1] }

   if { $flag == 0 || $flag == 1 } {
     set money [mc:getstat gold $id]
     set sbet 0

     if {[info exist mc(tot.cbets)]} {
       set obet ""
       foreach nbet $mc(tot.cbets) {
         if {[lindex $nbet 0] == $id && [lindex $nbet 1] == $num } {
           set flag 8
           set sbet [lindex $nbet 2]
           incr money $sbet
           if {!$mc(tot.debug)} { mc:setstat gold $id $money }
         } {
           set obet [lappend obet $nbet]
         }
       }
       set mc(tot.cbets) $obet
     }

     if {$bet == 0 && $sbet == 0} {
       set flag 10
     } elseif {$bet == 0} {
       set flag 9
       set bet $sbet
       if {$mc(tot.cbets)==""} { unset mc(tot.cbets) }
     } elseif {[expr $bet+$mc(tot.ostatok)]>$money} {
       set flag 4
       set bet $money
     } else {
       if {![info exist mc(tot.cbets)]} { set mc(tot.cbets) "" }
       set mc(tot.cbets) [lappend mc(tot.cbets) "$id $num $bet"]
       if {!$mc(tot.debug)} { mc:setstat gold $id [expr $money - $bet] }
     }
   }

   if { $flag != 5 } { set num [lindex $mc(tot.sv.clist) $num] }
   set cml ""
   switch -- $flag {
     0 { set cml "COM BET" }
     1 { set cml "COM BET" }
     8 { set cml "COM REBET" }
     9 { set cml "COM CLEAR" }
   }

   if {$cml!=""} { mc:tot:log [lindex $p 0] $cml "$bet on [ms:dfl $num]" }
   mc:tot:toclient cbetreply "$flag [lindex $p 0] {$num} $bet"
}


proc mc:tot:bets {p} {
   global mc
   if {$mc(tot.state) == 0} { return }
   set id [tolower $p]
   if {![mc:userexists $id]} { return }

   set bets ""
   if {[info exist mc(tot.bets)]} {
     foreach nbet $mc(tot.bets) {
       if {[lindex $nbet 0] == $id} {
         set bets [lappend bets $nbet]
       }
     }
   }

   mc:tot:toclient saybets "$p {$bets}"
}

proc mc:tot:parsefromclient {bn c t} {
   global mc

   if {![mc:istotal]} { return }
   if {[string tolower $bn] != [string tolower $mc(tot.client)]} { return }
   set cm [lindex $t 0]
   set param [mc:unbotnet [lrange $t 1 end]]
   switch -- $cm {
     bet  { mc:tot:recivebet  $param }
     cbet { mc:tot:recivecbet $param }
     stat { mc:tot:recivestat $param }
     join { mc:tot:join $param }
     bets { mc:tot:bets $param }
     default { mc:tot:log ServErr $cm $param }
   }

   return
}

proc mc:tot:reset {} {
   global mc

   if {[info exist mc(tot.client)]} { unset mc(tot.client) }
   if {[info exist mc(tot.server)]} { unset mc(tot.server) }
   putlog "total reset..."
}