
### name       :  .
### shop       :     .
### race       :  .
### prof       :  .
### wear       :   . [ <abc>,<de>,<flk>,<...> ]
###                   ,    - ",".
### fixedput   :      . [ 1/0 ]
### fixedrem   :      . [ 1/0 ]
### hark       :      [ <str>/0 <dex>/0 <wis>/0 <int>/0 <con>/0 ]
### price      :   [ 0/... ]
### weapon     :     . [ 0/1/2 ]
###              0 -  ; 1 -   ; 2 -   .
### atcmod     :     . [ 1/2/3 ]
###              1 - , 2 - , 3 - .
### hit        : ,   [ AxB ]
### heal       :   . [1/0]
### atc        :  .
### prt        :  .
### plushark   :  . [ <str>/0 <dex>/0 <wis>/0 <int>/0 <con>/0 ]
### ? harkdeps   : hark dependencies (ASLL)
### remort     :   . [ 1/0 ]
###              1 -     ; 0 - .
### maxhp      :   .
### maxmp      :    (  ).
### gethp      :      [ {0 AxB/d} {1 %/AxB/d} ]
### getmp      :      [ {0 AxB/d} {1 %/AxB/d} ]
###              0 -    ,      
###            !  1 -      -
###                AxB   .    AxB   ,
###                     ,     .
### drainhit   :          [ %/AxB/d ]
### drainmana  :          [ %/AxB/d ]

if { [array exist shopn] } { unset shopn }

set shopn(a) "  "
set shopn(b) "  "
set shopn(c) " "
set shopn(d) " "
set shopn(e) " "
set shopn(f) "  "
set shopn(g) " "
set shopn(h) "  "
set shopn(i) " "
set shopn(j) " "
set shopn(k) " "
set shopn(l) " "
set shopn(m) " "
#set shopn(p) "  "
#set shopn(q) "    "
#set shopn(r) "  "
#set shopn(s) "    "
#set shopn(v) " "
#set shopn(w) " "

if { [array exist wearp] } { unset wearp }

set wearp(a) " "
set wearp(b) " "
set wearp(c) ""
set wearp(d) ""
set wearp(e) ""
set wearp(f) " "
set wearp(g) ""
set wearp(h) ""
set wearp(i) ""
set wearp(j) " "
set wearp(k) " "
set wearp(l) " "
set wearp(m) " "
set wearp(n) ""
set wearp(o) ""

###  
if { [array exist weapontype] } { unset weapontype }
set weapontype(0) "  ,  !:)"
set weapontype(1) " "
set weapontype(2) " "

###         
if { [array exist weaponweight] } { unset weaponweight }
set weaponweight(0) " !  !:)"
set weaponweight(1) "1.15 {}"
set weaponweight(2) "1.25 {}"
set weaponweight(3) "1.45 {}"

proc mc:wget {wid h {id ""} {unical 1}} {
    global thi

    if { $id != "" } {
        foreach pr [mc:getstat eq $id] {
            if { [lindex $pr 1] == $wid } {
                ###     " "
                if { $unical == 1 } {
                    foreach pp [lindex $pr 4] {
                        if { [lindex $pp 0] == $h } {
                            return [lindex $pp 1]
                        }
                    }
                }
                ###     
                foreach pp $thi([lindex $pr 0]) {
                    if { [lindex $pp 0] == $h } {
                        return [lindex $pp 1]
                    }
                }
                ###     
                foreach pp $thi() {
                    if { [lindex $pp 0] == $h } {
                        return [lindex $pp 1]
                    }
                }
                return 0
            }
        }
        return 0
    }
    if { [info exist thi($wid)] } {
        foreach pp $thi($wid) {
            if { [lindex $pp 0] == $h } {
                return [lindex $pp 1]
            }
        }
    }
    foreach pp $thi() {
        if { [lindex $pp 0] == $h } {
            return [lindex $pp 1]
        }
    }

    return 0
}

###       .
proc mc:wfound {wid h id} {
    foreach pr [mc:getstat eq $id] {
        if { [lindex $pr 1] == $wid } {
            foreach pp [lindex $pr 4] {
                if { [lindex $pp 0] == $h } {
                    return [lindex $pp 1]
                }
            }
            return
        }
    }

    return
}

###     
proc mc:wset {wid h id param} {
  set neweq ""
  foreach pr [mc:getstat eq $id] {
    if { [lindex $pr 1] == $wid } {
      set found 0
      set newpr ""
      foreach pp [lindex $pr 4] {
        if { [lindex $pp 0] == $h } {
          set pp [lreplace $pp 1 1 $param]
          set found 1
        }
        lappend newpr $pp
      }
      if {!$found} {
        lappend newpr "$h $param"
      }
      set pr [lreplace $pr 4 4 $newpr]
    }
    lappend neweq $pr
  }
  mc:setstat eq $id $neweq
}

###     $param    .
proc mc:shop:summa {id param type} {
    set res "-"

    foreach e [mc:getstat eq $id] {
        if { [lindex $e 2] == 0 } { continue }

        set stat [mc:wget [lindex $e 1] $param $id]
        if { $stat == 0 } { continue }

        switch -- $type {
            "x" {
                if { [string first "x" $stat] != -1 } {
                    if { $res != "-" } {
                        set min [lindex [split $res "x"] 0]
                        set max [lindex [split $res "x"] 1]
                    } else {
                        set min 0.0
                        set max 0.0
                    }
                    set min [expr $min + [lindex [split $stat "x"] 0] ]
                    set max [expr $max + [lindex [split $stat "x"] 1] ]
                    set res "${min}x${max}"
                }
            }
            "d" {
                if { [isnumber $stat] != 0 } {
                    if { $res == "-" } { set res 0 }
                    set res [expr $res + $stat ]
                }
            }
            "%" {
                if { [string first "%" $stat] != -1 } {
                    if { $res == "-" } { set res 0 }
                    set res [expr $res + [string trim $stat "%"] ]
                }
            }
        }
    }

    return $res
}

proc mc:shop:calc {id param} {
    global mc mcs ct

    set result ""

    set base [mc:shop:summa $id $param "d"]
    if { $base == "-" } { set base 0.0 }

    set result [mc:shop:summa $id $param "x"]
    if { $result != "-" } {
        set min [lindex [split [lindex $result 0] "x"] 0]
        set max [lindex [split [lindex $result 0] "x"] 1]
    } else {
        set min 0.0
        set max 0.0
    }
    set min [expr $min + $base ]
    set max [expr $max + $base ]
    set result "${min}x${max}"

    set tmp [mc:shop:summa $id $param "%"]
    if { $tmp != "-" } {
        set result [lappend result "$tmp"]
    } else {
        set result [lappend result "0"]
    }

    if { $result != "-" } { return $result }
    return 0
}

proc mc:isallowwield {n id} {
  global mc liv allowwield ct

  if {$mc(phase) == 0} { return 0 }
  if {![array exist liv] || ![info exist liv($id)]} { return 0 }
  if {[array exist allowwield] && [info exist allowwield($id)] } { return 0 }
  mc:msg $n $ct(dow4)
  return 1
}

proc mc:xwield {n uh h t} {
    global ct cth wearp

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    mc:msg $n "  !w   !wield,      - !unwield."
}

proc mc:wield {n uh h t} {
    global mc ct cth wearp

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [llength $t] < 2 } {
        mc:msg $n $cth(wieldf)
        return
    }

    set nd [join [lindex [split $t] 1]]
    set y 0
    foreach pr [mc:getstat eq $id] {
        if { [lindex $pr 1] == $nd } {
            set y 1
            set nd $pr
            break
        }
    }

    if { $y == 1 && [lindex $nd 2] == 1 } {
        if { ![mc:checkin "a" [lindex $nd 3]] && ![mc:checkin "b" [lindex $nd 3]] } {
            mc:msg $n "[mc:wget [lindex $nd 0] name]   ."
            return
        }
        ###    
        set wear [split [lindex $nd 3] ""]
        set wearout ""
        for { set i 0 } { $i < [llength $wear] } { incr i } {
            set wearout [lappend wearout $wearp([lindex $wear $i])]
        }
        set wearout [join $wearout $ct(shopdel)]

        set wield [mc:getstat wield $id]

        set thand ""
        set rhand ""
        set lhand ""
        if { [mc:checkin "a" [lindex $nd 3]] && [mc:checkin "b" [lindex $nd 3]] } {
            set thand [lindex $nd 1]
        } elseif { [mc:checkin "a" [lindex $nd 3]] } {
            set rhand [lindex $nd 1]
        } elseif { [mc:checkin "b" [lindex $nd 3]] } {
            set lhand [lindex $nd 1]
        }

        set error 0
        if { $thand != "" } {
        ###   
            set wield [lreplace $wield 0 0 $thand]
            set wield [lreplace $wield 1 1 $thand]
        } elseif { $rhand != "" } {
        ###   
            set alter [lindex $wield 1]
            foreach e [mc:getstat eq $id] {
                if { [lindex $e 1] == $alter && [lindex $e 2] != 1 } {
                    set alter "-"
                    break
                }
            }
           # putlog "ALTER: $alter ([mc:wget $alter atcmod $id]) ! RHAND: $rhand ([mc:wget $rhand atcmod $id])"

            if { $alter != "-" } {
                if { [mc:wget $rhand heal $id] != [mc:wget $alter heal $id] } {
                    set error 1
                    set alter "-"
                } elseif { [mc:wget $rhand weapon $id] != [mc:wget $alter weapon $id] } {
                    set error 2
                    set alter "-"
                } elseif { [mc:wget $rhand weapon $id] == 2 && [mc:wget $alter weapon $id] == 2 } {
                    set error 3
                    set alter "-"
                } elseif { [mc:wget $rhand atcmod $id] == 3 && [mc:wget $alter atcmod $id] == 3 } {
                    set error 4
                    set alter "-"
                } elseif { [mc:getstat prof $id] == "p" && ([mc:wget $alter atcmod $id] >= 2 && [mc:wget $rhand atcmod $id] >= 2) } {
                    set error 5
                    set alter "-"
                } elseif { [mc:getstat prof $id] == "m" && ([mc:wget $alter atcmod $id] > 1 || [mc:wget $rhand atcmod $id] > 1) } {
                    set error 6
                    set alter "-"
                }
            }
            set wield [lreplace $wield 0 0 $rhand]
            set wield [lreplace $wield 1 1 $alter]
        } elseif { $lhand != "" } {
        ###   
            set alter [lindex $wield 0]
            foreach e [mc:getstat eq $id] {
                if { [lindex $e 1] == $alter && [lindex $e 2] != 1 } {
                    set alter "-"
                    break
                }
            }
           # putlog "ALTER: $alter ([mc:wget $alter atcmod $id]) ! RHAND: $lhand ([mc:wget $lhand atcmod $id])"

            if { $alter != "-" } {
                if { [mc:wget $lhand heal $id] != [mc:wget $alter heal $id] } {
                    set error 1
                    set alter "-"
                } elseif { [mc:wget $lhand weapon $id] != [mc:wget $alter weapon $id] } {
                    set error 2
                    set alter "-"
                } elseif { [mc:wget $lhand weapon $id] == 2 && [mc:wget $alter weapon $id] == 2 } {
                    set error 3
                    set alter "-"
                } elseif { [mc:wget $lhand atcmod $id] == 3 && [mc:wget $alter atcmod $id] == 3 } {
                    set error 4
                    set alter "-"
                } elseif { [mc:getstat prof $id] == "p" && ([mc:wget $alter atcmod $id] >= 2 && [mc:wget $lhand atcmod $id] >= 2) } {
                    set error 5
                    set alter "-"
                } elseif { [mc:getstat prof $id] == "m" && ([mc:wget $alter atcmod $id] > 1 || [mc:wget $lhand atcmod $id] > 1) } {
                    set error 6
                    set alter "-"
                }
            }
            set wield [lreplace $wield 0 0 $alter]
            set wield [lreplace $wield 1 1 $lhand]
        }


        if { $error != 0 } {
            mc:msg $n [format $cth(wielde${error}) ]
        }

        mc:setstat wield $id $wield

        mc:msg $n [format $cth(wields) [mc:wget [lindex $nd 0] name] [lindex $nd 1] $wearout]

        if { $mc(phase) > 0 } { mc:autoclear $n }
    } elseif { $y == 0 } {
        mc:msg $n $cth(wieldn)
    } else {
        mc:msg $n [format $cth(wieldw) [mc:wget [lindex $nd 0] name] [lindex $nd 1]]
    }
}

proc mc:unwield {n uh h t} {
    global mc ct cth wearp

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [llength $t] < 2 } {
        mc:msg $n $cth(unwieldf)
        return
    }

    set nd [join [lindex [split $t] 1]]
    set y 0
    foreach pr [mc:getstat eq $id] {
        if { [lindex $pr 1] == $nd && [lindex $pr 2] == 1 } {
            set y 1
            set nd $pr
            break
        }
    }

    if { $y == 1 } {
        if { [mc:wget [lindex $nd 0] weapon] == 0 } {
            mc:msg $n "[mc:wget [lindex $nd 0] name]   ."
            return
        }

        set wield ""
        foreach weapon [mc:getstat wield $id] {
            if { [lindex $nd 1] == $weapon } {
                set wield [lappend wield "-"]
            } else {
                set wield [lappend wield $weapon]
            }
        }
        mc:setstat wield $id $wield

        mc:msg $n [format $cth(unwields) [mc:wget [lindex $nd 0] name] [lindex $nd 1]]

        if { $mc(phase) > 0 } { mc:autoclear $n }
    } else {
        mc:msg $n $cth(unwieldn)
    }
}

proc mc:autoclear {n} {
    global mc ct cth oldtodo

    set id [mc:makeid $n]

#    mc:mclear $n * * "!clear"

    if { ![mc:check $id 1] } { return }
    if { ![info exists liv($id)] } { return }
    ###    !  
    if { [info exist killed($id)] && $killed($id) == 1 } { return }

    if { [info exist oldtodo($id)] } { unset oldtodo($id) }

    set todo($id) ""
    set prc($id) 100
    mc:msg $n $ct(clearo)

    putlog "[ms:dfl "todo(04[ms:dfl [mc:getstat nick $id]]) = 06AUTO-CLEAR"]"
}

proc mc:meq {n uh h t} {
    global cth wearp thicoll ct

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    set pr [mc:getstat eq $id]
    set out ""
    set wer ""

    foreach p $pr {
        if { [string length $out] >= 270 } {
            mc:msg $n [format $cth(69d) [join $out ", "]]
            set out ""
        }

        ###    
        set tout ""
        if { [lindex $p 3] != "-" } {
            set wear [split [lindex $p 3] ""]
            for {set i 0} {$i < [llength $wear]} {incr i} {
                set tout [lappend tout $wearp([lindex $wear $i])]
            }
            set tout [join $tout $ct(shopdel)]
        }
        if { [lsearch -exact [mc:getstat wield $id] [lindex $p 1]] != -1 && [lindex $p 2] != 0 } {
            set wer [lappend wer $p]
        }
        if { [lindex $p 2] == 1 } {
            set ttt "[mc:wget [lindex $p 1] name $id]"
            ###        ,    
            foreach col [array names thicoll] {
                if {[mc:incoll [lindex $p 0] $col] && [mc:fullcoll $id $col]} {
                    set ttt "04$ttt10"
                }
            }
        } else {
            set ttt "[mc:wget [lindex $p 1] name $id]"
        }
        if { $tout != "" } {
            set ttt "$ttt \($tout\)"
        }
        set out [lappend out [format $cth(69g) [lindex $p 1] $ttt]]
    }
    mc:msg $n [format $cth(69d) [join $out ", "]]

    set out ""
    set rweapon ""
    set lweapon ""
    set tweapon ""

    foreach weapon $wer {
        if { [mc:checkin "a" [lindex $weapon 3]] } {
            set rweapon [lindex $weapon 1]
        }
        if { [mc:checkin "b" [lindex $weapon 3]] } {
            set lweapon [lindex $weapon 1]
        }
    }
    if { $rweapon != "" && $lweapon != "" && $rweapon == $lweapon } {
        set tweapon $rweapon
    }

    if { $tweapon != "" } {
        set out [format $cth(69t) [format $cth(69x) "[mc:wget $tweapon name $id]" $tweapon]]
    } else {
        if { $rweapon == "" } {
            set out [lappend out [format $cth(69r) ""]]
        } else {
            set out [lappend out [format $cth(69r) [format $cth(69x) "[mc:wget $rweapon name $id]" $rweapon]]]
        }
        if { $lweapon == "" } {
            set out [lappend out [format $cth(69l) ""]]
        } else {
            set out [lappend out [format $cth(69l) [format $cth(69x) "[mc:wget $lweapon name $id]" $lweapon]]]
        }
        set out [join $out ", "]
    }

    mc:msg $n $out
}

proc mc:mshop {n uh h t} {
    global mcs mc ct cth
    global thi wear shopn shopt

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    set shops ""
    foreach sp [lsort -ascii [array names shopn]] {
        set shops [lappend shops $sp]
    }
    set shops [join $shops]
    regsub -all "\[\[:space:\]\]" $shops "" shops

    if { [llength $t] < 2 } {
        mc:msg $n [format $cth(6) $shops]
        return
    }
    set tt [lindex [ms:fl $t] 1]
    if { [info exist shopt($tt)] } {
        mc:mshoptal $n $uh $h $t
        return
    }
    if { ![info exist shopn($tt)] || $tt == "-" } {
        mc:msg $n [format $cth(6) $shops]
        return
    }

    set mayrace [mc:getstat race $id]
    set mayprof [mc:getstat prof $id]

    set tout ""
    set stuff ""
    set mstuff ""
    set nstuff ""

    if { [llength $t] > 2 && [lindex $t 2] == "all" } {
        set all 1
    } else {
        set all 0
    }

    foreach e [array names thi] {
        if { $e == "" } { continue }

        if { [mc:checkin $tt [mc:wget $e shop]] && [mc:wget $e price] > 0 } {

            if { [mc:wget $e race] != 0 && ![mc:checkin $mayrace [split [mc:wget $e race] ","]] } { continue }
            if { [mc:wget $e prof] != 0 && ![mc:checkin $mayprof [split [mc:wget $e prof] ","]] } { continue }

            set priceapply 100
            foreach tal [mc:getstat inv $id] {
                set tid [lindex $tal 0]
                set tcount [expr [llength $tal] - 1]
                if { $tcount <= 0 } { continue }

                switch -- $tid {
                    gac {
                    ### 
                        set priceapply [expr $priceapply - $tcount * [mc:wgettal $tid param1]]
                    }
                }
            }
            set priceapply [expr $priceapply * 0.01]
            set price [max 1 [expr2 0 [mc:wget $e price] * 1.0 * $priceapply]]

            if { ![mc:harksok $e $id] || $price > [mc:getstat gold $id] } {
                set nstuff [lappend nstuff "$e $price $priceapply"]
            } else {
                set mstuff [lappend mstuff "$e $price $priceapply"]
            }
        }
    }

    set mstuff [lsort -ascii   -index 0 $mstuff]
    set mstuff [lsort -integer -index 1 $mstuff]
    set nstuff [lsort -ascii   -index 0 $nstuff]
    set nstuff [lsort -integer -index 1 $nstuff]

    if { $all == 1 } {
        set stuff "$mstuff $nstuff"
    } else {
        set stuff "$mstuff"
    }

    foreach e $stuff {
        if { [string length $tout] >= 280 } {
            set tout [join $tout ", "]
            mc:msg $n [format $cth(6b) $shopn($tt) $tout]
            set tout ""
        }

        set price [lindex $e 1]

        set color "03"
        if { [lindex $e 2] != 1.0 } { set color "04" }

        if { ![mc:harksok [lindex $e 0] $id] || $price > [mc:getstat gold $id] } {
            set tout [lappend tout "14[lindex $e 0].[mc:wget [lindex $e 0] name]\(${color}${price}g14\)"]
        } else {
            set tout [lappend tout "10[lindex $e 0].[mc:wget [lindex $e 0] name]\(${color}${price}g10\)"]
        }
    }

    if { $tout == "" } {
        set tout $cth(6a)
    } else {
        set tout [join $tout ", "]
    }

    mc:msg $n [format $cth(6b) $shopn($tt) $tout]
}

proc mc:buy {n uh h t} {
    global cth thi shopn

    set id [mc:makeid $n]

    if {![mc:check $id -]} { return }

    if {[llength $t] < 2} {
        mc:msg $n $cth(7)
        return
    }
    set mx [lindex [split $t] 1]
    if {![info exist thi($mx)]} {
        mc:msg $n $cth(8)
        return
    }
    if {[mc:checkin "-" [mc:wget $mx shop]]} {
        mc:msg $n $cth(8)
        return
    }
    if {[mc:wget $mx race] != 0 && ![mc:checkin [mc:getstat race $id] [split [mc:wget $mx race] ","]]} {
        mc:msg $n $cth(8)
        return
    }
    if {[mc:wget $mx prof] != 0 && ![mc:checkin [mc:getstat prof $id] [split [mc:wget $mx prof] ","]]} {
        mc:msg $n $cth(8)
        return
    }

    set priceapply 100
    foreach tal [mc:getstat inv $id] {
        set tid [lindex $tal 0]
        set tcount [expr [llength $tal] - 1]
        if {$tcount <= 0} { continue }

        switch -- $tid {
            gac {
            ### 
                set priceapply [expr $priceapply - $tcount * [mc:wgettal $tid param1]]
            }
        }
    }
    set priceapply [expr $priceapply * 0.01]
    set price [max 1 [expr2 0 [mc:wget $mx price] * 1.0 * $priceapply]]

    if {[mc:getstat gold $id] < $price || [mc:wget $mx price] == 0} {
        mc:msg $n $cth(9)
        return
    }

    foreach pp [mc:getstat eq $id] {
        set tarr([lindex $pp 1]) 1
    }
    set nn 0
    for {set i 0} {$i <= [array size tarr]} {incr i} {
        if {![info exist tarr($i)]} {
            set nn $i
            break
        }
    }

    set oldeq [mc:getstat eq $id]
    mc:setstat eq $id [lappend oldeq "$mx $nn 0 - {}"]
    mc:setstat gold $id [expr [mc:getstat gold $id] - $price]
    mc:msg $n [format $cth(10) [mc:wget $mx name] $nn $price]
    mc:wset $nn price $id $price
    mc:sorteq $id
}

proc mc:sell {n uh h t} {
    global cth fset

    set id [mc:makeid $n]

    if {![mc:check $id -]} {return}
    if {[llength $t] < 2} {
        mc:msg $n $cth(11)
        return
    }

    set pr [mc:getstat eq $id]
    set nn [lindex [split $t] 1]
    if {$nn <= 0} {
        mc:msg $n "   ."
        return
    }
    set prr ""
    set th ""
    foreach pp $pr {
        if {[lindex $pp 1] == $nn} {
            set th $pp
        } else {
            set prr [lappend ppr $pp]
        }
    }

    if { $th != "" } {
      set th [lindex $th 0]
      set price [mc:wget $nn price $id]
      if { [mc:checkin "-" [mc:wget $th shop]] || [mc:wget $nn price $id] == 0 || [mc:wfound $nn nosell $id] == 1} {
        mc:msg $n "    ."
        return
      }

      mc:setstat eq $id $prr
      mc:setstat gold $id [expr2 0 [mc:getstat gold $id] + $price * 0.9]

      mc:msg $n [format $cth(14) [mc:wget $th name] [expr2 0 $price * 0.9 ]]

        ###    wield,         
        set newwield ""
        foreach weapon [mc:getstat wield $id] {
            if {$nn == $weapon} {
                set newwield [lappend newwield "-"]
            } else {
                set newwield [lappend newwield $weapon]
            }
        }
        mc:setstat wield $id $newwield

        ###     
        set changenames ""
        set neweset ""
        set number $nn
        foreach nn [mc:getstat eset $id] {
            set tempeset ""
            set newelems ""
            set isweapon 0
            foreach elem [lindex $nn 1] {
                if {[lindex $elem 0] != $number} {
                    set newelems [lappend newelems $elem]
                } else {
                    set changenames [lappend changenames [lindex $nn 0]]
                    if {[lindex $elem 0] == [lindex $nn 2]} { set isweapon 1 }
                }
            }
            if {$newelems != ""} {
                set tempeset [lappend tempeset [lindex $nn 0]]
                set tempeset [lappend tempeset $newelems]
                if {$isweapon == 0} {
                    set tempeset [lappend tempeset [lindex $nn 2]]
                } else {
                    set tempeset [lappend tempeset 0]
                }
            }
            if {$tempeset != ""} {
                set neweset [lappend neweset $tempeset]
            }
        }
        if {$neweset == ""} { set neweset 0 }
        if {$changenames != ""} {
            set changenames [join $changenames "10,04 "]
            set changenames "04$changenames10"
            mc:msg $n [xformat3 $fset(17) "" $changenames]
        }
        mc:setstat eset $id $neweset
    } else {
        mc:msg $n $cth(12)
    }
}

proc mc:puton {n uh h t} {
    global mcs mc ct cth ctasll wearp thicoll
    global race prof

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [llength $t] < 2 } {
        mc:msg $n $cth(16)
        return
    }
    set nnn [lindex $t 1]
    if { ![isnumber $nnn] } {
        mc:esetput $n $h $uh $nnn
        return
    }
    set wear 0
    if { [llength $t] >= 3 } { set wear [lindex $t 2] }

    ###          
    ###     - ,    "fixed"
    set saveeq [mc:getstat eq $id]

    set tmvv ""
    set y 0
    foreach p [mc:getstat eq $id] {
        if { [lindex $p 1] == $nnn } {
            set y 1
            set ttm $p
            set pars [split [mc:wget [lindex $ttm 1] wear $id] ","]

            if { [llength $pars] == 1 } { set wear 1 }
            if { $wear == 0 } {
                mc:msg $n "    ! $cth(16)"
                return
            } elseif { ![isnumber $wear] || $wear > [llength $pars] } {
                mc:msg $n "  !"
                return
            } else {
                set pars [lindex $pars [expr $wear - 1]]
            }
            set peq $p
            set peq [lreplace $peq 2 2 1]
            set peq [lreplace $peq 3 3 $pars]
            set tmvv [lappend tmvv $peq]
        } else {
            set tmvv [lappend tmvv $p]
        }
    }

    regsub -all \[ab\] $pars "" tpars
    if {$tpars != "" && [mc:isallowwield $n $id]} { return }


    if { $mc(phase) >= 1 } {
        ###     "fixed",  
        if { [mc:wget [lindex $ttm 1] fixedput $id] == 1 } {
            mc:msg $n [format $cth(putfixed) [mc:wget [lindex $ttm 1] name $id] [lindex $ttm 1] ]
            return
        }
        ###    "fixed"
        foreach col [array names thicoll] {
            if { ![mc:fullcoll $id $col] || [mc:wgetcoll $col fixedput] == 0 } { continue }
            if { [mc:incoll [lindex $ttm 0] $col] == 1 } {
                mc:msg $n [format $cth(putfixedc) [mc:wgetcoll $col name]]
                return
            }
        }
    }

    if { ![mc:harksok $ttm $id] } {
        mc:msg $n $cth(putonh)
        return
    }

    if { [mc:wget $ttm race $id] != 0 && ![mc:checkin [mc:getstat race $id] [split [mc:wget $ttm race $id] ","]] } {
        mc:msg $n [xformat3 $cth(putonr) "[mc:getstat sex $id]" [lindex [lindex $race([mc:getstat race $id]) 0] [mc:getstat sex $id]]]
        return
    }
    if { [mc:wget $ttm prof $id] != 0 && ![mc:checkin [mc:getstat prof $id] [split [mc:wget $ttm prof $id] ","]] } {
        mc:msg $n [xformat3 $cth(putonp) "[mc:getstat sex $id]" ]
        return
    }

    if { $y == 1 } {
        set ptmvv ""
        set sss ""
        set pars [split $pars ""]

        foreach p $tmvv {
            set ipoff 0
            foreach pp $pars {
                if { [lindex $p 2] == 1 && [mc:checkin $pp [lindex $p 3]] } {
                    set ipoff 1
                    break
                }
            }
            if { [lindex $p 1] == $nnn } { set ipoff 0 }
            if { $ipoff == 1 } {
                if { $mc(phase) >= 1 } {
                    ###     "fixed",      
                    if { [mc:wget [lindex $p 1] fixedrem $id] == 1 } {
                        mc:setstat eq $id $saveeq
                        mc:msg $n [format $cth(putfixedb) [mc:wget [lindex $p 1] name $id] ]
                        return
                    }
                    ###    "fixed"
                    foreach col [array names thicoll] {
                        if { ![mc:fullcoll $id $col] || [mc:wgetcoll $col fixedrem] == 0 } { continue }
                        if { [mc:incoll [lindex $p 0] $col] == 1 } {
                            mc:setstat eq $id $saveeq
                            mc:msg $n [format $cth(putfixedb) [mc:wget [lindex $p 1] name $id] ]
                            return
                        }
                    }
                }
                set peq $p
                set peq [lreplace $peq 2 2 0]
                set peq [lreplace $peq 3 3 -]
                set ptmvv [lappend ptmvv $peq]
                set sss [lappend sss $p]
            } else {
                set ptmvv [lappend ptmvv $p]
            }
        }
        if { $sss != "" } {
            ###      
            set out ""
            foreach st $sss {
                set wear [split [lindex $st 3] ""]
                set wearout ""
                for { set i 0 } { $i < [llength $wear] } { incr i } {
                    set wearout [lappend wearout $wearp([lindex $wear $i])]
                }
                set wearout [join $wearout $ct(shopdel)]
                set out [lappend out [format $cth(putelem) [mc:wget [lindex $st 1] name $id] [lindex $st 1] $wearout]]
            }
            set out [join $out ", "]
            mc:msg $n [format $cth(putoffo) $out]
        }

        ###          
        set wear $pars
        set wearout ""
        for { set i 0 } { $i < [llength $wear] } { incr i } {
            set wearout [lappend wearout $wearp([lindex $wear $i])]
        }
        set wearout [join $wearout $ct(shopdel)]
        mc:msg $n [format $cth(21) [format $cth(putelem) [mc:wget [lindex $ttm 1] name $id] $nnn $wearout]]

        mc:setstat eq $id $ptmvv

        mc:autoputoff $n $saveeq

        if { $mc(phase) > 0 && [mc:wget $nnn weapon $id] > 0 } { mc:autoclear $n }
    } else {
        mc:msg $n $cth(17)
    }
}

proc mc:putoff {n uh h t} {
    global mcs mc ct cth wearp thicoll

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [llength $t] < 2 } {
        mc:msg $n $cth(putofff)
        return
    }
    set nnn [lindex $t 1]
    set tmvv ""
    set y 0
    set pars "-"

    ###          
    ###     - ,    "fixed"
    set saveeq [mc:getstat eq $id]

    foreach p [mc:getstat eq $id] {
        if { [lindex $p 1] == $nnn } {
            set peq $p
            set peq [lreplace $peq 2 2 0]
            set pars [lindex $peq 3]
            set peq [lreplace $peq 3 3 -]
            set tmvv [lappend tmvv $peq]
            set ttm $p
            set y 1
        } else {
            set tmvv [lappend tmvv $p]
        }
    }

    regsub -all \[ab\] $pars "" tpars
    if {$tpars != "" && [mc:isallowwield $n $id]} { return }

    if { $mc(phase) >= 1 } {
        ###     "fixed",  
        if { [mc:wget [lindex $ttm 1] fixedrem $id] == 1 } {
            mc:msg $n [format $cth(putfixed) [mc:wget [lindex $ttm 1] name $id] [lindex $ttm 1] ]
            return
        }
        ###    "fixed"
        foreach col [array names thicoll] {
            if { ![mc:fullcoll $id $col] || [mc:wgetcoll $col fixedrem] == 0 } { continue }
            if { [mc:incoll [lindex $ttm 0] $col] == 1 } {
                mc:msg $n [format $cth(putfixedc) [mc:wgetcoll $col name]]
                return
            }
        }
    }

    if { $y == 1 } {
        if { $pars != "-" } {
            ###          
            set wear [split $pars ""]
            set wearout ""
            for {set i 0} {$i < [llength $wear]} {incr i} {
                set wearout [lappend wearout $wearp([lindex $wear $i])]
            }
            set wearout [join $wearout $ct(shopdel)]
            mc:msg $n [format $cth(putoffo) [format $cth(putelem) [mc:wget [lindex $ttm 1] name $id] $nnn $wearout]]
        } else {
            mc:msg $n [format $cth(putoffo) [mc:wget [lindex $ttm 1] name $id]]
        }
        mc:setstat eq $id $tmvv
    } else {
        mc:msg $n $cth(putoffn)
    }

    mc:autoputoff $n $saveeq

    if { $mc(phase) > 0 && [mc:wget $nnn weapon $id] > 0 } { mc:autoclear $n }
}

###    
proc mc:autoputoff {n saveeq} {
    global mc mcs ct cth wearp thicoll

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    set stuff ""
    set sss ""
    foreach p [mc:getstat eq $id] {
        if { [lindex $p 2] == 1 && ![mc:harksok [lindex $p 0] $id] } {

            if { $mc(phase) >= 1 } {
                ###     "fixed",      
                if { [mc:wget [lindex $p 1] fixedrem $id] == 1 } {
                    mc:setstat eq $id $saveeq
                    mc:msg $n [format $cth(putfixedb) [mc:wget [lindex $p 1] name $id] ]
                    return
                }
                ###    "fixed"
                foreach col [array names thicoll] {
                    if { ![mc:fullcoll $id $col] || [mc:wgetcoll $col fixedrem] == 0 } { continue }
                    if { [mc:incoll [lindex $p 0] $col] == 1 } {
                        mc:setstat eq $id $saveeq
                        mc:msg $n [format $cth(putfixedb) [mc:wget [lindex $p 1] name $id] ]
                        return
                    }
                }
            }

            set peq $p
            set peq [lreplace $peq 2 2 0]
            set peq [lreplace $peq 3 3 -]
            set stuff [lappend stuff $peq]
            set sss [lappend sss $p]
        } else {
            set stuff [lappend stuff $p]
        }
    }
    if { $stuff != "" } { mc:setstat eq $id $stuff }
    if { $sss != "" } {
        ###      
        set out ""
        foreach st $sss {
            set wear [split [lindex $st 3] ""]
            set wearout ""
            for { set i 0 } { $i < [llength $wear] } { incr i } {
                set wearout [lappend wearout $wearp([lindex $wear $i])]
            }
            set wearout [join $wearout $ct(shopdel)]
            set out [lappend out [format $cth(putelem) [mc:wget [lindex $st 1] name $id] [lindex $st 1] $wearout]]
        }
        set out [join $out ", "]
        mc:msg $n "[format $cth(putoffo) $out] \[ \]"
    }
}

proc mc:sorteq {id} {
    set beeq [mc:getstat eq $id]
    set neweq ""

    if {[llength $beeq] == 1} { return }

    for {set i 0} {$i < [llength $beeq]} {incr i} {
        #putlog "!"
        set pos $i
        set num [lindex [lindex $beeq $i] 1]
        #putlog "i = $i, [lindex $beeq $i], num = $num"

        for {set j [expr $i + 1]} {$j < [llength $beeq]} {incr j} {
            #putlog "  j = $j, n = [lindex [lindex $beeq $j] 1]"
            if {$num > [lindex [lindex $beeq $j] 1]} {
                set pos $j
                set num [lindex [lindex $beeq $j] 1]
                #putlog "NEW pos = $pos, num = $num"
            }
        }

        #putlog "pos = $pos, num = $num"
        #putlog "1beeq  = $beeq"
        #putlog "1neweq = $neweq"
        set neweq [lappend neweq [lindex $beeq $pos]]
        set beeq [lreplace $beeq $pos $pos]
        #putlog "2beeq  = $beeq"
        #putlog "2neweq = $neweq"
        incr i -1
    }
    mc:setstat eq $id $neweq
}

proc mc:mwear {n uh h t} {
    global mcs mc ct cth thi wearp

    set id [mc:makeid $n]

    if {![mc:check $id -]} { return }

    if {[llength $t] < 2} {
        mc:msg $n $cth(wearf)
        return
    }
    set isnumber -1
    set mx [lindex $t 1]
    if {[isnumber $mx]} {
        set isnumber $mx
        foreach nn [mc:getstat eq $id] {
            if {[lindex $nn 1] == $mx} {
                set mx [lindex $nn 0]
                break
            }
        }
        if {[isnumber $mx]} { set mx "" }
    } else {
        if {![info exist thi($mx)]} { set mx "" }
        #if {[mc:getstat gold $id] < [mc:wget $mx price]} { set mx "" }
        if {[mc:wget $mx race] != 0 && ![mc:checkin [mc:getstat race $id] [split [mc:wget $mx race] ","]]} { set mx "" }
        if {[mc:wget $mx prof] != 0 && ![mc:checkin [mc:getstat prof $id] [split [mc:wget $mx prof] ","]]} { set mx "" }
    }
    if {$mx == ""} {
        mc:msg $n $cth(61)
        return
    }
    #                 
    if {[mc:wget $mx shop] == 0 || ($isnumber == -1 && [mc:checkin "-" [mc:wget $mx shop]])} {
        mc:msg $n $cth(61)
        return
    }

    set wear [mc:wget $mx wear]
    set wear [split $wear ","]
    set out ""
    for {set i 0} {$i < [llength $wear]} {incr i} {
        set twear [split [lindex $wear $i] ""]
        set tout ""
        foreach place $twear {
            set tout [lappend tout $wearp($place)]
        }
        set tout [join $tout $ct(shopdel)]
        set tout [format $cth(wear2) [expr $i + 1] $tout]
        set out [lappend out $tout]
    }
    set out [join $out ", "]

    set mx2 "$mx"
    if {[mc:checkin "-" [mc:wget $mx shop]]} { set mx2 "" }

    if {$isnumber > -1} {
        set template ""
        if {$mx2 != "" && [mc:wget $isnumber name $id] != [mc:wget $isnumber name $id 0]} {
            set template [format $cth(exte) $mx [mc:wget $isnumber name $id 0]]
        }
        mc:msg $n [format $cth(wear1) "03$isnumber10." [mc:wget $isnumber name $id] $template $out]
    } else {
        mc:msg $n [format $cth(wear1) "03$mx210." [mc:wget $mx name] "" $out]
    }
}

proc mc:explain {n uh h t} {
    global thi cth ct wear ctasll harksfull race prof
    global weapontype weaponweight

    set id [mc:makeid $n]

    if { ![mc:check $id -] } { return }

    if { [llength $t] < 2 } {
        mc:msg $n $cth(60)
        return
    }
    set mx [lindex [split $t] 1]
    set mid ""
    if { [isnumber $mx] } {
        set mx [expr round($mx)]
        set mid $id
        set iss 1
        foreach nn [mc:getstat eq $id] {
            if { [lindex $nn 1] == $mx } {
                set iss 0
                break
            }
        }
        if { $iss } {
            mc:msg $n $cth(61)
            return
        }
    } else {
        if { ![info exist thi($mx)] } {
            mc:msg $n $cth(61)
            return
        }
        #if { [mc:getstat gold $id] < [mc:wget $mx price] } {
        #    mc:msg $n $cth(61)
        #    return
        #}
        if { [mc:wget $mx race] != 0 && ![mc:checkin [mc:getstat race $id] [split [mc:wget $mx race] ","]] } {
            mc:msg $n $cth(61)
            return
        }
#        if { [mc:wget $mx prof] != 0 && ![mc:checkin [mc:getstat prof $id] [split [mc:wget $mx prof] ","]] } {
#            mc:msg $n $cth(61)
#            return
#        }
        ###           
        if { [mc:wget $mx shop] == 0 || [mc:checkin "-" [mc:wget $mx shop]] } {
            mc:msg $n $cth(61)
            return
        }
    }

    set out ""
    if { [mc:wget $mx hit $mid] != [mc:wget Default hit] } {
        if { [mc:wget $mx heal $mid] == 1 } {
            set out [lappend out [format $cth(65h) [mc:wget $mx hit $mid]]]
        } else {
            set out [lappend out [format $cth(65) [mc:wget $mx hit $mid]]]
        }
    }
    if { [mc:wget $mx atc $mid] != [mc:wget Default atc] } {
        if { [mc:wget $mx atc $mid] >= 0 } {
            set out [lappend out [format $cth(66) "+[mc:wget $mx atc $mid]"]]
        } else {
            set out [lappend out [format $cth(66) [mc:wget $mx atc $mid]]]
        }
    }
    if { [mc:wget $mx prt $mid] != [mc:wget Default prt] } {
        if { [mc:wget $mx prt $mid] >= 0 } {
            set out [lappend out [format $cth(67) "+[mc:wget $mx prt $mid]"]]
        } else {
            set out [lappend out [format $cth(67) [mc:wget $mx prt $mid]]]
        }
    }

    if { [mc:wget $mx plushark $mid] != [mc:wget Default plushark] } {
        set ph [mc:wget $mx plushark $mid]

        set pstr [lindex $ph 0]
        set pdex [lindex $ph 1]
        set pwis [lindex $ph 2]
        set pint [lindex $ph 3]
        set pcon [lindex $ph 4]

        if { $pstr > 0 } { set pstr "+$pstr" }
        if { $pdex > 0 } { set pdex "+$pdex" }
        if { $pwis > 0 } { set pwis "+$pwis" }
        if { $pint > 0 } { set pint "+$pint" }
        if { $pcon > 0 } { set pcon "+$pcon" }

        if { $pstr != 0 } {
            set out [lappend out "str:03$pstr10"]
        }
        if { $pdex != 0 } {
            set out [lappend out "dex:03$pdex10"]
        }
        if { $pwis != 0 } {
            set out [lappend out "wis:03$pwis10"]
        }
        if { $pint != 0 } {
            set out [lappend out "int:03$pint10"]
        }
        if { $pcon != 0 } {
            set out [lappend out "con:03$pcon10"]
        }
    }

    set mharks [mc:wget $mx hark $mid]
    set mho ""
    set harkn 0
    set parmn 1
    set plrharks(1) [mc:getstat str $id]
    set plrharks(2) [mc:getstat dex $id]
    set plrharks(3) [mc:getstat wis $id]
    set plrharks(4) [mc:getstat int $id]
    set plrharks(5) [mc:getstat con $id]

    foreach hark $mharks {
        if { $hark > 0 } {
            if {[expr $hark + 5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) $parmn]] > $plrharks($parmn)} {
                set mho [lappend mho [format $ctasll(2) [lindex $harksfull $harkn] [expr $hark + 5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) $parmn]]]]
            } else {
                set mho [lappend mho [format $ctasll(3) [lindex $harksfull $harkn] [expr $hark + 5 * [mc:getstat remort $id] * [lindex $race([mc:getstat race $id]) $parmn]]]]
            }
        }
        incr harkn
        incr parmn
    }
    set mho [join $mho "/"]

    set template ""
    set mx2 "!"
    if { [mc:wget $mx child $mid] } {
        ###   ,     
        if {[isnumber $mx]} {
            foreach tmp [mc:getstat eq $id] {
                if {[lindex $tmp 1] == $mx} {
                    set mx2 [lindex $tmp 0]
                }
            }
        }
        set template [format $cth(exte) $mx2 [mc:wget $mx name $mid 0]]
        if { [mc:checkin "-" [mc:wget $mx2 shop]] } { set template "" }
    }

    ### 
    set price [mc:wget $mx price $mid]
    set price " (03${price}g10)"
    if { [mc:checkin "-" [mc:wget $mx shop $mid]] } { set price "" }

    ###  
    set wtype ""
    if { [mc:wget $mx weapon $mid] > 0 && [info exists weapontype([mc:wget $mx weapon $mid])] } {
        set wtype [format $cth(exwp) $weapontype([mc:wget $mx weapon $mid])]
    }
    ###  
    set wweight ""
    if { $wtype != "" && [mc:wget $mx atcmod $mid] > 0 && [info exists weaponweight([mc:wget $mx atcmod $mid])] } {
        set wweight [format $cth(exwe) [lindex $weaponweight([mc:wget $mx atcmod $mid]) 1] [lindex $weaponweight([mc:wget $mx atcmod $mid]) 0]]
    }

    ###  /
    set drainout ""
    set stat [mc:wget $mx drainhit $mid]
    if { $stat != 0 } {
        if { [string first "%" $stat] != -1 } {
            set drainout [lappend drainout [format $cth(exhd) "$stat  "]]
        } else {
            regsub -all "x" $stat "10x03" stat
            set drainout [lappend drainout [format $cth(exhd) $stat]]
        }
    }
    set stat [mc:wget $mx drainmana $mid]
    if { $stat != 0 } {
        if { [string first "%" $stat] != -1 } {
            set drainout [lappend drainout [format $cth(exmd) "$stat  "]]
        } else {
            regsub -all "x" $stat "10x03" stat
            set drainout [lappend drainout [format $cth(exmd) $stat]]
        }
    }
    if { $drainout != "" } {
        set drainout [join $drainout "/"]
    }

    ###  
    set gethpout ""
    set pos [mc:wget $mx gethp $mid]
    if { $pos == 0 } { set pos "" }
    switch -- [lindex $pos 0] {
      0 {
        set pos [lindex $pos 1]
        regsub -all "x" $pos "10x03" pos
        set gethpout [format $cth(exgh) "()03$pos10"]
      }
      1 {
        set pos [lindex $pos 1]
        if { [string first "%" $pos] != -1 } {
          set pos "$pos  "
        } elseif { [string first "x" $pos] } {
          regsub -all "x" $pos "10x03" pos
        }
        set gethpout [format $cth(exgh) "( )03$pos10"]
      }
    }

    ###  
    set getmpout ""
    set pos [mc:wget $mx getmp $mid]
    if { $pos == 0 } { set pos "" }
    switch -- [lindex $pos 0] {
      0 {
        set pos [lindex $pos 1]
        regsub -all "x" $pos "10x03" pos
        set getmpout [format $cth(exgm) "()03$pos10"]
      }
      1 {
        set pos [lindex $pos 1]
        if { [string first "%" $pos] != -1 } {
          set pos "$pos  "
        } elseif { [string first "x" $pos] } {
          regsub -all "x" $pos "10x03" pos
        }
        set getmpout [format $cth(exgm) "( )03$pos10"]
      }
    }

    set stat [mc:wget $mx maxhp $mid]
    if {$stat != 0} {
      regsub -all "x" $stat "10x03" stat
      set maxout "[format $cth(exmxh) $stat]"
    } { set maxout "" }
    set stat [mc:wget $mx maxmp $mid]
    if {$stat != 0} {
      regsub -all "x" $stat "10x03" stat
      if {$maxout!=""} { append maxout "/" }
      append maxout [format $cth(exmxm) $stat]
    }

    set stat [mc:wget $mx reghp $mid]
    if {$stat != 0} {
      regsub -all "x" $stat "10x03" stat
      set regout "[format $cth(exrgh) $stat]"
    } { set regout "" }
    set stat [mc:wget $mx regmp $mid]
    if {$stat != 0} {
      regsub -all "x" $stat "10x03" stat
      if {$regout!=""} { append regout "/" }
      append regout [format $cth(exrgm) $stat]
    }

    set tout ""
    set tout [lappend tout [format $cth(64) $mx [mc:wget $mx name $mid] $price $wtype $wweight $template]]
    set tout [lappend tout [format $cth(exbs) [join $out "/"]]]
    if { $mho != "" } { set tout [lappend tout [format $cth(exmh) $mho]] }
    if { $drainout != "" } { set tout [lappend tout "\[$drainout\]"] }
    if { $gethpout != "" } { set tout [lappend tout "\[$gethpout\]"] }
    if { $getmpout != "" } { set tout [lappend tout "\[$getmpout\]"] }
    if { $maxout   != "" } { set tout [lappend tout "\[$maxout\]"] }
    if { $regout   != "" } { set tout [lappend tout "\[$regout\]"] }

    ### 
    set out ""
    if { [mc:wget $mx remort $mid] != 0 } {
        set out [lappend out $cth(exre)]
    }
    if { [mc:wget $mx price $mid] == 0 || [mc:wget $mx nosell $mid] == 1 } {
        set out [lappend out $cth(exse)]
    }
    if { $out != "" } {
        set out [join $out ", "]
        set out "\($out\)"
        set tout [lappend tout $out]
    }
    set tout [join $tout ", "]
    mc:msg $n $tout
}

###  . ^x^  ctrl+k<x>
proc mc:shop:colors {string} {
    global clr

    ###  
    set clr(cbg) "10"
    ###   
    set clr(ca) "12"
    ###   
    set clr(cv) "06"
    ###  
    set clr(cd) "04"

    ###   
    set clr(cmbg) "03"
    ###   
    set clr(cmd) "04"
    ###    
    set clr(cmb) "07"
    ###   
    set clr(cmg) "07"

    set colors ""
    foreach cl [array names clr] {
        set colors [lappend colors "^${cl}^ $clr($cl)"]
    }
    set colors [join $colors]

    set string [string map $colors $string]

    return $string
}

proc mc:shop:load {} {
    global mc thi ct

    if { [array exist thi] } { unset thi }
    set thi() "
        {name      {Default}       }
        {shop      a               }
        {race      [mc:allrace]    }
        {prof      [mc:allprof]    }
        {wear      a               }
        {hark      {0 0 0 0 0}     }
        {price     0               }
        {weapon    0               }
        {heal      0               }
        {hit       0x0             }
        {atc       0               }
        {prt       0               }
        {harkdeps  1               }
        {plushark  {0 0 0 0 0}     }
        {remort    0               }
        {_hit      {$ct(31)}       }
        {_miss     {$ct(32)}       }
    "

    set fnl [glob -directory $mc(file.shop) "*.shop"]
    set cnt  0

    foreach fn $fnl {
        set fid [open $fn r]
        set id ""

        while { ![eof $fid] } {
            gets $fid l
            if { $l == "" || [string range $l 0 0] == ";" || [string range $l 0 0] == "#" } { continue }
            if { [lindex $l 0] == "name" } {
                if { $id != "" } {
                    set thi($id) $item
                    incr cnt
                }
                set id [lindex $l 1]
                set item "{name {[lrange $l 2 end]}}"
                if {[info exist thi($id)]} {
                  putlog "Warning! while loading shop: item $id is replased."
                }
            } else {
                if { [llength $l] <= 2 } {
                    lappend item "[lindex $l 0] [lrange $l 1 end]"
                } else {
                    lappend item "[lindex $l 0] {[join [lrange $l 1 end]]}"
                }
            }
        }
        if { $id != "" } {
            set thi($id) $item
            incr cnt
        }
        close $fid
    }

    putlog "Loaded $cnt SHOP-items."
}
