
### 0 3 {nick pass com ?comadd?}
### 1 7 {race prof sex ptitle title trace regstr fmaster}
### 2 10 {remort level exp gold favor nodrop noexp hold mode skp}
### 3 7 {rstr rdex rwis rint rcon free hbase}
### 4 4 {eq w eset inv}
### 5 3 {bonus {magic} {skill}}
### 6 7 {game win pool ctime ltime run death}

### 0 - comname
### 1 - user list {nick access}
### 2 - games num
### 3 - win num
### 4 - 1/0 - private/public
### 5 - last game time
### 6 - register time


#           "#" -    
proc mc:stripline {v} {
  upvar $v vr
  if {[string length $vr]==0} { return }
  set vr [string trimleft $vr]
  if {[string first "#" $vr]==0} { set vr "" }
}

#     
#   ton -   (/)
#   frm -   
#   lst -       frm    irc
#   alst -    lst     irc
#   jn   -   join.   - lst   
#   islast
proc mc:out {ton frm lst alst jn} {
  upvar $lst onout
  set tmpout $onout
  lappend tmpout $alst
  set tmpout [join $tmpout $jn]
  if {[string length [format $frm $tmpout]]>250} {
    set onout [join $onout $jn]
    mc:msg $ton [format $frm $onout]
    set onout ""
  }
  lappend onout $alst
}

proc mc:lastout {ton frm lst jn} {
  upvar $lst onout
  if {$onout==""} { return }
  set onout [join $onout $jn]
  mc:msg $ton [format $frm $onout]
}

proc mc:userexists {id} {
   global mcs
   return [info exist mcs($id)]
}

proc mc:makeid {n} {
    return [tolower [ms:fl $n]]
}

proc mc:check {id t} {
    global mc mcs

    if { $t != "-" && $mc(phase) != $t } { return 0 }
    if { ![info exists mcs($id)] } { return 0 }

    return [mc:checkident $id]
}

proc mc:checkident {id} {
    global mc ct mctn

    if { [mc:getstat pass $id] == "-nopass-" } { return 1 }
    if { [string index [mc:getstat pass $id] 0] == "-" } { return 0 }
    if { ![info exist mc(ident)] || [lsearch -exact $mc(ident) $id] == -1 } {
        if { [array exist mctn] } {
            foreach nn [array names mctn] {
                if { $mctn($nn) == $id } {
                    return 1
                }
            }
        }

       # putserv "NOTICE [mc:getstat nick $id] :$ct(0)"
        if {[mc:modeok $id "priv-warn"]} {
          mc:msg [mc:getstat nick $id] $ct(0)
        } {
          mc:notice [mc:getstat nick $id] $ct(0)
        }
        return 0
    }

    return 1
}

proc mc:mver {n uh h t}   { mc:ver $n }
proc mc:pver {n uh h c t} { mc:ver $n }

proc mc:ver {nick} {
    global mc version admin

    puthelp "NOTICE $nick :$mc(cop). Channel: $mc(chan). BotAdmin: $admin."
}

#      
proc mc:calcaveragelevel {} {
    global mc mcs

    set count 1
    set summa 0
    set mc(averagelevel) 0
    foreach id [array names mcs] {
        if {[string range $id 0 3]=="fuck"} { continue }
        incr count
        set summa [expr $summa + [mc:getstat level $id] + [mc:getstat remort $id]]
    }
    set mc(averagelevel) [expr round($summa * 2.0 / $count)]
    putlog "AverageLevel: $mc(averagelevel), Count: $count, Summa: $summa"
}

#      
proc mc:numending {arg suf1 suf2 suf3} {
    set num2  "[string index $arg [expr [string length $arg] - 2]][string index $arg [expr [string length $arg] - 1]]"
    set num1 "[string index $arg [expr [string length $arg] - 1]]"

    if {![isnumber $arg]} { return }

    switch -- $num1 {
        0 { set suffix $suf1 }
        1 { set suffix $suf1 }
        2 { set suffix $suf2 }
        3 { set suffix $suf3 }
        4 { set suffix $suf1 }
        5 { set suffix $suf1 }
        6 { set suffix $suf2 }
        7 { set suffix $suf2 }
        8 { set suffix $suf2 }
        9 { set suffix $suf1 }
    }
    if {$num2 > 10 && $num2 <= 20} {
        set suffix $suf1
    }

    return $suffix
}

proc mc:adjending {number} {
    if {![isnumber $number] || $number > 999} { return }

    set del [split $number ""]

    set unit(0)  ""
    set unit(1)  ""
    set unit(2)  ""
    set unit(3)  ""
    set unit(4)  ""
    set unit(5)  ""
    set unit(6)  ""
    set unit(7)  ""
    set unit(8)  ""
    set unit(9)  ""
    set unit(11) ""
    set unit(12) ""
    set unit(13) ""
    set unit(14) ""
    set unit(15) ""
    set unit(16) ""
    set unit(17) ""
    set unit(18) ""
    set unit(19) ""

    set ten(00) ""
    set ten(0)  ""
    set ten(10) ""
    set ten(1)  ""
    set ten(20) ""
    set ten(2)  ""
    set ten(30) ""
    set ten(3)  ""
    set ten(40) ""
    set ten(4)  ""
    set ten(50) ""
    set ten(5)  ""
    set ten(60) ""
    set ten(6)  ""
    set ten(70) ""
    set ten(7)  ""
    set ten(80) ""
    set ten(8)  ""
    set ten(90) ""
    set ten(9)  ""

    set hundred(10) ""
    set hundred(1)  ""
    set hundred(20) ""
    set hundred(2)  ""
    set hundred(30) ""
    set hundred(3)  ""
    set hundred(40) ""
    set hundred(4)  ""
    set hundred(50) ""
    set hundred(5)  ""
    set hundred(60) ""
    set hundred(6)  ""
    set hundred(70) ""
    set hundred(7)  ""
    set hundred(80) ""
    set hundred(8)  ""
    set hundred(90) ""
    set hundred(9)  ""

    for {set i [expr [llength $del] - 1]} {$i >= 0} {incr i -1} {
        set list([expr [llength $del] - $i]) [lindex $del $i]
    }

    set out $unit($list(1))

    if {$number > 9} {
        if {$list(2) == 1 && $list(1) != 0} {
            set out $unit(1$list(1))
        }
        if {$list(1) == 0} {
            set out $ten($list(2)0)
        }
        if {$list(1) != 0} {
            if {$ten($list(2)) != ""} {
                set out "$ten($list(2)) $out"
            }
        }
    }
    if {$number > 99} {
        if {$list(1) == 0 && $list(2) == 0} {
            set out $hundred($list(3)0)
        }
        if {$list(1) == 0 && $list(2) != 0} {
            set out "$hundred($list(3)) $out"
        }
        if {$list(1) != 0} {
            if {$hundred($list(3)) != ""} {
                set out "$hundred($list(3)) $out"
            }
        }
    }

    return $out
}

proc mc:magicapply {id magic} {
    global mr
    set bonus 0
    set level [string index $magic 0]

    set level [expr $level * 2 - 1]
    #putlog "2level = $level, [mc:getstat level $id]"
    if { $level >= [mc:getstat level $id] } { return 0 }

    if { [mc:getstat prof $id] == "m" } {
        set bonus [format "%.2f" [expr [mc:getstat wis $id] * 0.4 / 30.0 + [mc:getstat int $id] * 0.6 / 30.0 * (1 + $mr(${magic}f)) / $level]]
    } elseif {[mc:getstat prof $id] == "p"} {
        set bonus [format "%.2f" [expr [mc:getstat wis $id] * 0.6 / 30.0 + [mc:getstat int $id] * 0.4 / 30.0 * (1 + $mr(${magic}f)) / $level]]
    }
#    putlog "MEffApply for $magic for [ms:dfl [mc:getstat nick $id]] = $bonus (wis = [mc:getstat wis $id], int = [mc:getstat int $id], mf = $mr(${magic}f))"

    return $bonus
}

proc mc:levelexpeapply {id targ} {
    set apply 1.00
    if { [mc:getstat level $id] >= [mc:getstat level $targ] || ([mc:getstat level $id] < [mc:getstat level $targ] && [mc:getstat remort $id] < [mc:getstat remort $targ]) } {
        set apply [format "%.2f" [expr ([mc:getstat level $id] - [mc:getstat level $targ]) * -0.05 + $apply]]
        set apply [format "%.2f" [expr ([mc:getstat remort $id] - [mc:getstat remort $targ]) * -0.05 + $apply]]
    }

#    putlog "LExpApply for [ms:dfl [mc:getstat nick $id]]\([mc:getstat level $id]/[mc:getstat remort $id]\) VS [ms:dfl [mc:getstat nick $targ]]\([mc:getstat level $targ]/[mc:getstat remort $targ]\) = $apply"

    return $apply
}

#      
proc mc:allrace {} {
    global race
    set temp ""
    foreach ra [array names race] {
        set temp [lappend temp $ra]
    }
    set temp [lsort -ascii $temp]
    set temp [join $temp]
    regsub -all "\[\[:space:\]\]" $temp "" temp
    return $temp
}

#      ,  $not
proc mc:notrace {not} {
    set temp [mc:allrace]
    for {set i 0} {$i < [string length $not]} {incr i} {
        regsub -all [string index $not $i] $temp "" temp
    }
    return $temp
}

#      
proc mc:allprof {} {
    global prof
    set temp ""
    foreach pr [array names prof] {
        set temp [lappend temp $pr]
    }
    set temp [lsort -ascii $temp]
    set temp [join $temp]
    regsub -all "\[\[:space:\]\]" $temp "" temp
    return $temp
}

#      ,  $not
proc mc:notprof {not} {
    set temp [mc:allprof]
    for {set i 0} {$i < [string length $not]} {incr i} {
        regsub -all [string index $not $i] $temp "" temp
    }
    return $temp
}

proc mc:mod {id n w} {
    global mcs
    set mcs($id) [lreplace $mcs($id) $n $n [expr [lindex $mcs($id) $n] + $w]]
}
proc mc:modset {id n w} {
    global mcs
    set mcs($id) [lreplace $mcs($id) $n $n $w]
}
proc mc:modget {id n} {
    global mcs
    return [lindex $mcs($id) $n]
}
proc mc:mcom {id n w} {
    global mco
    set mco($id) [lreplace $mco($id) $n $n [expr [lindex $mco($id) $n] + $w]]
}
proc mc:mcomset {id n w} {
    global mco
    set mco($id) [lreplace $mco($id) $n $n $w]
}
proc mc:mcomget {id n} {
    global mco
    return [lindex $mco($id) $n]
}

# ---------------------------------------- STAT ----------------------------------------

proc mc:getstat {stat id} {
    global mcs

    set id [mc:makeid $id]
    if {$id == "-fuck"} { return -1 }
    set temp 0

    switch -- $stat {
        nick    { return [lindex [lindex $mcs($id) 0] 0] }
        pass    { return [lindex [lindex $mcs($id) 0] 1] }
        com     { return [lindex [lindex $mcs($id) 0] 2] }

        race    { return [lindex [lindex $mcs($id) 1] 0] }
        prof    { return [lindex [lindex $mcs($id) 1] 1] }
        sex     { return [lindex [lindex $mcs($id) 1] 2] }
        ptitle  { return [lindex [lindex $mcs($id) 1] 3] }
        title   { return [lindex [lindex $mcs($id) 1] 4] }
        trace   { return [lindex [lindex $mcs($id) 1] 5] }
        regstr  { return [lindex [lindex $mcs($id) 1] 6] }
        fmaster { return [lindex [lindex $mcs($id) 1] 7] }

        remort { return [lindex [lindex $mcs($id) 2] 0] }
        level  { return [lindex [lindex $mcs($id) 2] 1] }
        exp    { return [lindex [lindex $mcs($id) 2] 2] }
        gold   { return [lindex [lindex $mcs($id) 2] 3] }
        favor  { return [lindex [lindex $mcs($id) 2] 4] }
        nodrop { return [lindex [lindex $mcs($id) 2] 5] }
        noexp  { return [lindex [lindex $mcs($id) 2] 6] }
        hold   { return [lindex [lindex $mcs($id) 2] 7] }
        mode   { return [lindex [lindex $mcs($id) 2] 8] }
        skp    { return [lindex [lindex $mcs($id) 2] 9] }

        rstr   { return [lindex [lindex $mcs($id) 3] 0] }
        rdex   { return [lindex [lindex $mcs($id) 3] 1] }
        rwis   { return [lindex [lindex $mcs($id) 3] 2] }
        rint   { return [lindex [lindex $mcs($id) 3] 3] }
        rcon   { return [lindex [lindex $mcs($id) 3] 4] }
        free   { return [lindex [lindex $mcs($id) 3] 5] }
        hbase  { return [lindex [lindex $mcs($id) 3] 6] }
        str    {
                 set temp [mc:getstat rstr $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 0]]
                     }
                 }
                 return [max 0 $temp]
        }
        dex    {
                 set temp [mc:getstat rdex $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 1]]
                     }
                 }
                 return [max 0 $temp]
        }
        wis    {
                 set temp [mc:getstat rwis $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 2]]
                     }
                 }
                 return [max 0 $temp]
        }
        int    {
                 set temp [mc:getstat rint $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 3]]
                     }
                 }
                 return [max 0 $temp]
        }
        con    {
                 set temp [mc:getstat rcon $id]
                 foreach pr [mc:getstat eq $id] {
                     if {([llength [mc:wget [lindex $pr 1] plushark $id]] > 1) && ([lindex $pr 2])} {
                         set temp [expr $temp + [lindex [mc:wget [lindex $pr 1] plushark $id] 4]]
                     }
                 }
                 return [max 0 $temp]
        }

        eq     { return [lindex [lindex $mcs($id) 4] 0] }
        wield  { return [lindex [lindex $mcs($id) 4] 1] }
        eset   { return [lindex [lindex $mcs($id) 4] 2] }
        inv    { return [lindex [lindex $mcs($id) 4] 3] }

        bonus  { return [lindex [lindex $mcs($id) 5] 0] }
        magic  { return [lindex [lindex $mcs($id) 5] 1] }
        skill  { return [lindex [lindex $mcs($id) 5] 2] }

        game   { return [lindex [lindex $mcs($id) 6] 0] }
        win    { return [lindex [lindex $mcs($id) 6] 1] }
        pool   { return [lindex [lindex $mcs($id) 6] 2] }
        ctime  { return [lindex [lindex $mcs($id) 6] 3] }
        ltime  { return [lindex [lindex $mcs($id) 6] 4] }
        run    { return [lindex [lindex $mcs($id) 6] 5] }
        death  { return [lindex [lindex $mcs($id) 6] 6] }

        default {
            putlog "Error in MC:GetStat. Stat - $stat"
            return "#error#"
        }
    }
    return
}

proc mc:setstat {stat id set} {
    global mcs

    set id [mc:makeid $id]
    if {$id == "-fuck"} { return -1 }
    set temp ""

    switch -- $stat {
        nick   {
                 set temp [lindex $mcs($id) 0]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 0 0 $temp]
        }
        pass   {
                 set temp [lindex $mcs($id) 0]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 0 0 $temp]
        }
        com    {
                 set temp [lindex $mcs($id) 0]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 0 0 $temp]
        }

        race   {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        prof   {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        sex    {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        ptitle {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        title  {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 4 4 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        trace  {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 5 5 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        regstr {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 6 6 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }
        fmaster {
                 set temp [lindex $mcs($id) 1]
                 set temp [lreplace $temp 7 7 $set]
                 set mcs($id) [lreplace $mcs($id) 1 1 $temp]
        }

        remort {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        level  {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        exp    {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        gold   {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        favor  {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 4 4 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        nodrop {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 5 5 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        noexp  {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 6 6 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        hold   {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 7 7 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        mode   {
                 set temp [lindex $mcs($id) 2]
                 set temp [lreplace $temp 8 8 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }
        skp  {
                 set temp [lindex $mcs($id) 2]
                 while {[llength $temp]<10} { lappend temp 0 }
                 set temp [lreplace $temp 9 9 $set]
                 set mcs($id) [lreplace $mcs($id) 2 2 $temp]
        }

        str    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        dex    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        wis    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        int    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        con    {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 4 4 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        free   {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 5 5 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }
        hbase  {
                 set temp [lindex $mcs($id) 3]
                 set temp [lreplace $temp 6 6 $set]
                 set mcs($id) [lreplace $mcs($id) 3 3 $temp]
        }

        eq     {
                 set temp [lindex $mcs($id) 4]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 4 4 $temp]
        }
        wield  {
                 set temp [lindex $mcs($id) 4]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 4 4 $temp]
        }
        eset   {
                 set temp [lindex $mcs($id) 4]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 4 4 $temp]
        }
        inv    {
                 set temp [lindex $mcs($id) 4]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 4 4 $temp]
        }

        bonus  {
                 set temp [lindex $mcs($id) 5]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 5 5 $temp]
        }
        magic  {
                 set temp [lindex $mcs($id) 5]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 5 5 $temp]
        }
        skill  {
                 set temp [lindex $mcs($id) 5]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 5 5 $temp]
        }

        game   {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 0 0 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        win    {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 1 1 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        pool   {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 2 2 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        ctime  {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 3 3 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        ltime  {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 4 4 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        run    {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 5 5 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }
        death  {
                 set temp [lindex $mcs($id) 6]
                 set temp [lreplace $temp 6 6 $set]
                 set mcs($id) [lreplace $mcs($id) 6 6 $temp]
        }

        default {
            putlog "Error in MC:SetStat. Stat - $stat"
            return "#error#"
        }
    }
    return
}

# ---------------------------------------- /STAT ----------------------------------------

proc mc:getmaxhp {id} {
    global thi thicoll

    set mhp [expr [mc:getstat hbase $id] + 1.0 * [mc:getstat con $id] / 3]

    foreach ee [mc:getstat eq $id] {
        if { [lindex $ee 2] == 1 } { set mhp [expr $mhp + [mc:wget [lindex $ee 1] maxhp $id]] }
    }
    foreach col [array names thicoll] {
        if { ![mc:fullcoll $id $col] } { continue }
        set mhp [expr $mhp + [mc:wgetcoll $col maxhp]]
    }

    return [format "%.2f" $mhp]
}
proc mc:getrmaxhp {id} {
    return [format "%.2f" [expr [mc:getstat hbase $id] + 1.0 * [mc:getstat rcon $id] / 3]]
}
proc mc:getmaxmp {id} {
    global thicoll

    set mmp [expr [mc:getstat wis $id] * 1.5]

    foreach ee [mc:getstat eq $id] {
        if { [lindex $ee 2] == 1 } { set mmp [expr $mmp + [mc:wget [lindex $ee 1] maxmp $id]] }
    }
    foreach col [array names thicoll] {
        if { ![mc:fullcoll $id $col] } { continue }
        set mmp [expr $mmp + [mc:wgetcoll $col maxmp]]
    }

    return [format "%.2f" $mmp]
}
proc mc:getrmaxmp {id} {
    return [format "%.2f" [expr [mc:getstat rwis $id] * 1.5]]
}
